SimPart Class

class NXOpen.CAE.SimPart

Bases: NXOpen.CAE.CaePart

Represents an NX part of type .sim.

Use the NXOpen.PartCollection class to load or create a part.

New in version NX4.0.0.

Properties

Property Description
ComponentAssembly Returns the component assembly.
Displayed Returns true if the part represents a displayed part.
FemPart Returns the fem part associated with the sim part
FieldManager Returns the field main.
FullPath Returns the full path of the part.
HasWriteAccess Returns the write-access status of a part independent of the load state.
IsFullyLoaded Returns the load status of a part.
IsOccurrence Returns whether this object is an occurrence or not.
IsReadOnly Returns the read-only status of a part.
JournalIdentifier Returns the identifier that would be recorded in a journal for this object.
Leaf Returns the leaf name of the part.
Name Returns the custom name of the object.
OwningComponent Returns the owning component, if this object is an occurrence.
OwningPart Returns the owning part of this object
PartPreviewMode Returns or sets the preview mode
PartUnits Returns the units of the part file.
Prototype Returns the prototype of this object if it is an occurrence.
SaveDisplayFacets Returns or sets whether display quality facets are saved in the part file
Simulation Returns the NXOpen.CAE.SimSimulation object
Tag Returns the Tag for this object.
UniqueIdentifier Returns or sets the unique identifier for this part used to determine whether parts can be quietly substituted during part open.

Methods

Method Description
AssignPermanentName Saves a temporary part with the given name.
CanBeDisplayPart Returns true if the part can be displayed and false if not displayed.
Close Closes an open part.
CompleteStructure Make additions necessary to complete the incomplete assembly structure of the input part
CompressLabels Compress the labels of csys, physical, and groups
CreateAttributeIterator Create an attribute iterator
CreateConvertToConvergentBodyBuilder Creates a NXOpen.CAE.ConvertToConvergentBodyBuilder
CreateDynamicSectionBuilder Creates a NXOpen.Display.DynamicSectionBuilder The base part must be a displayable part, otherwise an exception will be thrown.
CreateEffectivityConditionBuilder Creates a NXOpen.EffectivityConditionBuilder
CreateFacetSettingsBuilder Creates a builder for the Facet Settings dialog
CreateGatewayGroupBuilder Creates a Groups builder
CreateImportSimBuilder Creates ImportSimulationBuilder.
CreateModelDisplayBuilder Creates a builder for model display controls command
CreatePerspectiveOptionsBuilder Creates a builder for the Perspective Options dialog
CreateReferenceSet Creates a NXOpen.ReferenceSet object
CreateSolverAppendOption Returns a solver append option object for importing the solver specific data into an existing NXOpen.CAE.FemPart or NXOpen.CAE.SimPart.
DeleteAllAttributesByType Deletes all attributes of a specific type.
DeleteAttributeByTypeAndTitle Deletes an attribute by type and title.
DeleteReferenceSet Deletes a NXOpen.ReferenceSet object
DeleteSolverAppendOption Deletes a solver append option object for importing the solver specific data into an existing NXOpen.CAE.FemPart or NXOpen.CAE.SimPart.
DeleteUserAttribute Deletes the first attribute encountered with the given Type, Title.
DeleteUserAttributes Deletes the attributes on the object, if any, that satisfy the given iterator
ExportJt Exports JT file
ExportSimulation Exports the Simulation data for a NXOpen.CAE.CaePart.
FinalizeCreation Finalizes the creation of the sim part file.
FindObject Finds the NXOpen.NXObject with the given identifier as recorded in a journal.
GetAllReferenceSets Get all the NXOpen.ReferenceSet objects in this part.
GetApplication Get the application which corresponds to the specified type.
GetArrangements Outputs the NXOpen.Assemblies.Arrangement objects within the given part.
GetAttributeTitlesByType Gets all the attribute titles of a specific type.
GetBooleanUserAttribute Gets a boolean attribute by Title and array Index.
GetCollaborativeContentType The collaborative content type of this part.
GetComputationalTimeUserAttribute Gets a time attribute by Title and array Index.
GetCsysFlattenedLabel Gets the resolved label of csys in cae part.
GetDescription Gets the description assoicated with the Cae part
GetHistoryInformation Get history of part
GetIncompleteStatus Inquire whether the provided part is flagged as being incomplete
GetIntegerAttribute Gets an integer attribute by title.
GetIntegerUserAttribute Gets an integer attribute by Title and array Index.
GetMakeUniqueName Gets the Unique name on a part for the Make Unique operation
GetNextUserAttribute Gets the next attribute encountered on the object, if any, that satisfies the given iterator.
GetPdmReferenceAttributeValue Gets the value of PDM Reference attribute for given object.
GetPreviewImage Get the preview image This will return the graphic preview image of the part (when available).
GetRealAttribute Gets a real attribute by title.
GetRealUserAttribute Gets a real attribute by Title and array Index.
GetReferenceAttribute Gets the reference string (not the calculated value) of a string attribute that uses a reference string.
GetStringAttribute Gets a string attribute value by title.
GetStringUserAttribute Gets a string attribute by Title and array Index.
GetTimeAttribute Gets a time attribute by title.
GetTimeUserAttribute Gets a time attribute by Title and array Index.
GetTransientStatus Inquire whether the provided part is flagged as being transient
GetUserAttribute Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index.
GetUserAttributeAsString Gets the first attribute encountered on the object, if any, with a given title, type and array index.
GetUserAttributeCount Gets the count of set attributes on the object, if any, that satisfy the given iterator.
GetUserAttributeLock Determine the lock of the given attribute.
GetUserAttributeSize Gets the size of the first attribute encountered on the object, if any, with a given Title and Type.
GetUserAttributeSourceObjects Returns an array of objects from which this object presents attributes.
GetUserAttributes Gets all the attributes that have been set on the given object, if any, that satisfy the given iterator.
GetUserAttributesAsStrings Gets all the attributes that have been set on the given object.
HasUserAttribute Determines if an attribute exists on the object, that satisfies the given iterator
ImportExistingSimulation Imports the solver specific data into an existing NXOpen.CAE.FemPart or NXOpen.CAE.SimPart.
ImportSim Imports all entities of selected type from the source sim into the current (target) sim.
LoadFeatureDataForSelection Ensure that feature data is loaded for a part.
LoadFully Ensures that this part is fully loaded.
LoadThisPartFully Ensures that this part is fully loaded.
LoadThisPartPartially Ensures that this part is at least partially loaded.
NewBeamSectionOffsetOptions Creates a NXOpen.CAE.BeamSectionOffsetOptions
NewBeamSectionOptions Creates a NXOpen.CAE.BeamSectionOptions
NewBeamSectionOrientationOptions Creates a NXOpen.CAE.BeamSectionOrientationOptions
NewMaterialOptions Creates a NXOpen.CAE.MaterialOptions
Print Prints a representation of this object to the system log file.
RegenerateDisplayFacets Regenerates display specific transient cached facets in the part.
ReinstateTransience Reinstate the transient status to the formerly transient input part
RelabelByOffsets Relabels the csys, physical, and group labels by the specified offset value
RemoveTransience Remove the transient status from the input part
Reopen Reopens a loaded part.
ReopenAs Reopens a loaded part.
ReverseBlankAll Reverse blank all the objects in the part.
Save Saves the part whether it is modified or not.
SaveAs Creates copy of target part.
SaveBookmark Saves a bookmark file.
SetAttribute Creates or modifies an integer attribute.
SetBooleanUserAttribute Creates or modifies a boolean attribute with the option to update or not.
SetDescription Sets the description assoicated with the Cae part
SetMakeUniqueName Sets the unique name on part for the Make Unique operation
SetName Sets the custom name of the object.
SetPdmReferenceAttribute Sets the value of PDM Reference attribute on the object.
SetReferenceAttribute Creates or modifies a string attribute which uses a reference string.
SetTimeAttribute Creates or modifies a time attribute.
SetTimeUserAttribute Creates or modifies a time attribute with the option to update or not.
SetUserAttribute Creates or modifies an attribute with the option to update or not.
SetUserAttributeLock Lock or unlock the given attribute.
Undisplay Undisplays the part, if it is currently a displayed part.

Structs

SimPartImportErrorCodes_Struct Struct Contains list of error codes for import of each entity type
SimPartImportOptions_Struct Struct Contains information about which entities to be imported

Property Detail

FemPart

SimPart.FemPart

Returns the fem part associated with the sim part

-------------------------------------

Getter Method

Signature FemPart

Returns:Fem part associated to the sim part
Return type:NXOpen.CAE.CaePart

New in version NX4.0.0.

License requirements: nx_masterfem (“Finite Element Modeling”) OR nx_design_sim (“NX Design Simulation”)

IsOccurrence

SimPart.IsOccurrence

Returns whether this object is an occurrence or not.

-------------------------------------

Getter Method

Signature IsOccurrence

Returns:This object is an occurrence
Return type:bool

New in version NX3.0.0.

License requirements: None.

JournalIdentifier

SimPart.JournalIdentifier

Returns the identifier that would be recorded in a journal for this object.

This may not be the same across different releases of the software.

-------------------------------------

Getter Method

Signature JournalIdentifier

Returns:
Return type:str

New in version NX3.0.0.

License requirements: None.

Name

SimPart.Name

Returns the custom name of the object.

-------------------------------------

Getter Method

Signature Name

Returns:
Return type:str

New in version NX3.0.0.

License requirements: None.

OwningComponent

SimPart.OwningComponent

Returns the owning component, if this object is an occurrence.

-------------------------------------

Getter Method

Signature OwningComponent

Returns:
Return type:NXOpen.Assemblies.Component

New in version NX3.0.0.

License requirements: None.

OwningPart

SimPart.OwningPart

Returns the owning part of this object

-------------------------------------

Getter Method

Signature OwningPart

Returns:The owning part of this object or null if it does not have an owner
Return type:NXOpen.BasePart

New in version NX3.0.0.

License requirements: None.

Prototype

SimPart.Prototype

Returns the prototype of this object if it is an occurrence.

-------------------------------------

Getter Method

Signature Prototype

Returns:The prototype of this object or null if this object is not an occurrence
Return type:NXOpen.INXObject

New in version NX3.0.0.

License requirements: None.

Simulation

SimPart.Simulation

Returns the NXOpen.CAE.SimSimulation object

-------------------------------------

Getter Method

Signature Simulation

Returns:NXOpen.CAE.SimSimulation
Return type:NXOpen.CAE.SimSimulation

New in version NX4.0.0.

License requirements: nx_masterfem (“Finite Element Modeling”) OR nx_design_sim (“NX Design Simulation”)

Method Detail

CompressLabels

SimPart.CompressLabels

Compress the labels of csys, physical, and groups

Signature CompressLabels(compressCsysLabels, compressPhysLabels, compressGroupLabels)

Parameters:
  • compressCsysLabels (bool) – compress the csys labels
  • compressPhysLabels (bool) – compress the physical labels
  • compressGroupLabels (bool) – compress the group labels

New in version NX12.0.0.

License requirements: nx_masterfem (“Finite Element Modeling”)

CreateImportSimBuilder

SimPart.CreateImportSimBuilder

Creates ImportSimulationBuilder.

This imports selected entities of different type from the source sim into the current (target) sim.

Signature CreateImportSimBuilder()

Returns:The ImportSimulationBuilder object
Return type:NXOpen.CAE.ImportSimulationBuilder

New in version NX11.0.0.

License requirements: nx_masterfem (“Finite Element Modeling”) OR nx_design_sim (“NX Design Simulation”)

FinalizeCreation

SimPart.FinalizeCreation

Overloaded method FinalizeCreation

  • FinalizeCreation(femPart, description)
  • FinalizeCreation(femPart, femLayerOpt, description)

-------------------------------------

Finalizes the creation of the sim part file. This method should be called immediately after creating the sim part file. This method should be called only once for each sim part file. The second call to the method will raise an error.

Signature FinalizeCreation(femPart, description)

Parameters:

New in version NX4.0.0.

License requirements: nx_masterfem (“Finite Element Modeling”) OR nx_design_sim (“NX Design Simulation”)

-------------------------------------

Finalizes the creation of the sim part file. This method should be called immediately after creating the sim part file. This method should be called only once for each sim part file. The second call to the method will raise an error.

Signature FinalizeCreation(femPart, femLayerOpt, description)

Parameters:
  • femPart (NXOpen.CAE.CaePart) – the fem part file NXOpen.CAE.FemPart
  • femLayerOpt (int) – layer option. -1 = USE_ORIGINAL, 0 = USE_WORK
  • description (list of str) – description

New in version NX6.0.0.

License requirements: nx_masterfem (“Finite Element Modeling”) OR nx_design_sim (“NX Design Simulation”)

-------------------------------------

FindObject

SimPart.FindObject

Finds the NXOpen.NXObject with the given identifier as recorded in a journal.

An object may not return the same value as its JournalIdentifier in different versions of the software. However newer versions of the software should find the same object when FindObject is passed older versions of its journal identifier. In general, this method should not be used in handwritten code and exists to support record and playback of journals.

An exception will be thrown if no object can be found with the given journal identifier.

Signature FindObject(journalIdentifier)

Parameters:journalIdentifier (str) – Journal identifier of the object
Returns:
Return type:NXOpen.INXObject

New in version NX3.0.0.

License requirements: None.

ImportSim

SimPart.ImportSim

Imports all entities of selected type from the source sim into the current (target) sim.

The FeModelOccurrence of the target sim onto which the user needs to import needs to be passed in. The input will be an array of FeModelOccurrences, if user wants to import the same source sim onto multiple FeModelOccurrences of the target sim.

Signature ImportSim(fileName, prependString, selOptions, selectedFemoccs)

Parameters:
Returns:

list of generated error codes during import

Return type:

NXOpen.CAE.SimPartImportErrorCodes_Struct

New in version NX7.5.0.

License requirements: nx_masterfem (“Finite Element Modeling”) OR nx_design_sim (“NX Design Simulation”)

Print

SimPart.Print

Prints a representation of this object to the system log file.

Signature Print()

New in version NX3.0.0.

License requirements: None.

RelabelByOffsets

SimPart.RelabelByOffsets

Relabels the csys, physical, and group labels by the specified offset value

Signature RelabelByOffsets(csysOffset, physOffset, groupOffset)

Parameters:
  • csysOffset (int) – csys offset
  • physOffset (int) – physical offset
  • groupOffset (int) – group offset

New in version NX12.0.0.

License requirements: nx_masterfem (“Finite Element Modeling”)

SetName

SimPart.SetName

Sets the custom name of the object.

NOTE: This method should not be used to edit a read-only object such as a Mirrored PMI object. If it is, the changes will be overridden when the part is updated.

Signature SetName(name)

Parameters:name (str) –

New in version NX3.0.0.

License requirements: None.